SystemOrganization addCategory: #'TpFinalSquash-Core'!
SystemOrganization addCategory: #'TpFinalSquash-TestCases'!

Object subclass: #Club
	instanceVariableNames: 'nombre jugadores partidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Club class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
nuevoConNombre:nombreClub
	^ (self new) nombre: nombreClub ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:43'!
clubAgregarNuevoJugador: nombreJugador conRanking:ranking  fecha: enFecha
| jugador |
"Envia mensaje a la clase Jugador para crear un nuevo jugador y lo carga en la coleccion de jugadores de esta clase"
	jugador := self clubBuscarJugador: nombreJugador.
	
	(jugador = nil)
		ifTrue: [jugadores add: (Jugador nuevoJugador: nombreJugador  ranking: ranking fecha: enFecha)]! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:44'!
clubAsignarRanking: nuevoRanking nombre: nombreJugador fecha: unaFecha
| jugador |
"Envia mensaje a la clase Jugador para asignar un ranking al jugador en una fecha, se valida que el jugador exista"
	jugador := self clubBuscarJugador: nombreJugador.
	
	(jugador ~= nil)
		ifTrue: [jugador jugadorAsignarRanking: nuevoRanking fecha: unaFecha esAsignado: true]
	
	
! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:47'!
clubBuscarJugador: nombreJugador
"Busca un jugador por su nombre en la coleccion de jugadores(variable de instancia)"
	^ jugadores detect: [:each | (each name ) = nombreJugador] ifNone:[^ nil].! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:49'!
clubBuscarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha
"Busca un partido por su fecha y oponentes en la coleccion de partidos(variable de instancia)"
	^ partidos detect: [:each | (((each fecha  = enFecha) & (each jugador1 name = nombreJugador1)) & (each jugador2 name = nombreJugador2 ))] ifNone:[nil].! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:52'!
clubBuscarRanking: nombreJugador fecha: enFecha
| jugador rankingSalida |
"Busca un jugador por su nombre en la coleccion de jugadores(variable de instancia) y luego le envia un mensaje a dicho jugador para pedirle su ranking en una determinada fecha"	
	jugador := self clubBuscarJugador: nombreJugador.
	
	(jugador ~= nil)
		ifTrue: [	^ rankingSalida := (jugador jugadorBuscarRankingfecha: enFecha ) ranking ]! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/23/2013 19:07'!
clubEditarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha nuevoResultado: nResultado nuevafecha: nuevaFecha
| partido |
"Edita el partido entre 2 jugadores en la fecha especificada en la coleccion partidos(variable de instancia) luego envia mensaje a cada jugador del partido para que actualicen los partidos en los que participaron y actualizen sus ranking dependientes, se valida que el partido exista
PILA, revisar donde la fecha nueva es distinta"
			
	partido := self clubBuscarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha.
	((partido ~= nil) & (((partido jugador1 rankings first fecha)  <= nuevaFecha ) & ((partido jugador2 rankings first fecha) <= nuevaFecha )))
		ifTrue: [		
				"Edito el partido de la coleccion local"
				partido gamesJugador1: (nResultado at: 1) gamesJugador2: (nResultado at: 2)  fecha: nuevaFecha.
				"Envia mensaje a los oponentes del partido para que editen sus partidos y actualizen sus ranking dependientes"
				partido jugador1 jugadorEditarPartido: enFecha  nuevoResultado: nResultado   nuevafecha: nuevaFecha.
				partido jugador2 jugadorEditarPartido: enFecha  nuevoResultado: nResultado   nuevafecha: nuevaFecha 
		]
! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:58'!
clubEditarRanking: nombreJugador fecha: enFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
|jugador|
"Envia mensaje a un jugador para editar un ranking en una fecha, se valida que el jugador exista"
	jugador  := self clubBuscarJugador: nombreJugador.
	
	(jugador ~= nil)
			ifTrue: [(jugador jugadorEditarRankingFecha: enFecha  ranking: nuevoRanking  nuevaFecha: nuevaFecha )]
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:01'!
clubEliminarPartidoJugador1: nombreJugador1 jugador2: nombreJugador2 fecha: enFecha
| jugadorLocal1 g1 jugadorLocal2 g2 aux1 aux2 partidoLocal|
"Elimina de la coleccion de partidos(variable de instancia) el partido especificado, desde aqui se envia el mensaje a la clase partido
donde se implementa el mensaje que elimina el partido, tambien se le envia mensaje a cada jugador el partido en el que acaba de participar asi lo elimina de su historico de partidos, con jugadorLocal1 name mando el nombre y con jugadorLocal1 mando el objeto"

	jugadorLocal1 := jugadores detect: [:each | each name = nombreJugador1 ].
	jugadorLocal2 := jugadores detect: [:each | each name = nombreJugador2 ].

	partidos do: [:partido | ((partido fecha = enFecha) & (partido jugador1 = jugadorLocal1 & partido jugador2 = jugadorLocal2)) ifTrue: [ partidoLocal:= partido.partidos remove: partido ] ].

	
	aux1:= ((jugadorLocal1 jugadorBuscarRankingAnteriorfecha: enFecha ) ranking ) . aux2:= ((jugadorLocal2 jugadorBuscarRankingAnteriorfecha: enFecha) ranking).
	jugadorLocal1 jugadorEliminarPartido: partidoLocal rankingActualJ1: aux1 rankingActualJ2: aux2 .
	jugadorLocal2 jugadorEliminarPartido: partidoLocal rankingActualJ1: aux1 rankingActualJ2: aux2 .! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:01'!
clubEliminarRanking: nombreJugador fecha: enFecha
| jugador rankingSalida|	
"Envia mensaje a un jugador para eliminar un ranking de una determinada fecha"	
	jugador := self clubBuscarJugador: nombreJugador.
	
	(jugador ~= nil)
		ifTrue: [jugador jugadorEliminarRankingfecha: enFecha]
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/23/2013 19:14'!
clubJugadoresCercanos: nombreJugador valor: unValor
| jugador |
"Envia mensaje al jugador para retornar jugadores cuyo ranking actual se encuentran por encima o
por debajo del ranking del jugador en cuestion no mas del valor ingresado"

	jugador  := self clubBuscarJugador: nombreJugador.
	
	(jugador ~= nil)
		ifTrue: [
			^ (jugador jugadorRankingSimilaresPorValor: unValor jugador: jugadores)
			]! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:08'!
clubNuevoPartidoJugador1: nombreJugador1 jugador2: nombreJugador2 fecha: unaFecha resultado: unVector
| jugadorLocal1 g1 jugadorLocal2 g2 aux1 aux2|
"Carga en la coleccion de partidos(variable de instancia) el nuevo partido, desde aqui se envia el mensaje al partido para 
crear el partido, tambien se le envia mensaje a cada jugador del partido en el que acaba de participar asi lo almacena en su historico de partidos, con jugadorLocal1 name mando el nombre y con jugadorLocal1 mando el objeto
se debe validar que la fecha del partido a agregar no sea anterior a la fecha ingreso de cada jugador y tampoco sea igual a ninguna fecha cargada en el historico de los jugadores"

	jugadorLocal1 := self clubBuscarJugador: nombreJugador1.
	jugadorLocal2 := self clubBuscarJugador: nombreJugador2.

	((jugadorLocal1 jugadorValidarFecha: unaFecha ) & (jugadorLocal2 jugadorValidarFecha: unaFecha  ))
	ifTrue: [
	g1 := unVector at: 1.
	g2 := unVector at: 2.
	partidos add: (Partido agregarPartidoEntre: jugadorLocal1 y: jugadorLocal2 fecha: unaFecha  gamesJugador1: g1 gamesJugador: g2 ).
	
	aux1:= ((jugadorLocal1 jugadorBuscarRankingfecha: unaFecha) ranking ) . aux2:= ((jugadorLocal2 jugadorBuscarRankingfecha: unaFecha) ranking).
	jugadorLocal1 jugadorAgregarPartido: (partidos last) rankingActualJ1: aux1 rankingActualJ2: aux2 .
	jugadorLocal2 jugadorAgregarPartido: (partidos last) rankingActualJ1: aux1 rankingActualJ2: aux2 .
		]! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:11'!
clubOrdenarJugadoresPorRanking: coleccionJugadores
"Ordena una coleccion de jugadores por su ranking actual de manera desc"
| i j tamanio r1 temp|

		i := 1.tamanio := coleccionJugadores size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((coleccionJugadores at: i ) rankings last ranking  > (coleccionJugadores at: j) rankings last ranking )
										ifFalse: [temp := coleccionJugadores  at: i.
													coleccionJugadores at: i put: (coleccionJugadores at: j).
													coleccionJugadores at: j put: temp.											
													].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ coleccionJugadores! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:20'!
clubRankingJugadoresEntre: valorInferior y: valorSuperior
| coleccionJugadores |
coleccionJugadores := OrderedCollection new.
"Recorre la coleccion de jugadores y a cada jugador le va preguntando si su ranking actual esta dentro del rango especificado"

	
 ^ (self clubOrdenarJugadoresPorRanking: (jugadores reject: [:each | (each dentroRangoRanking: valorInferior superior: valorSuperior) = nil ])).

 



! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:01'!
initialize 
	jugadores := OrderedCollection new.
	partidos := OrderedCollection new! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:01'!
jugador: unaPosicion
	"Creo q este metodo nadie lo llama, permite obtener un jugador segun su posicion dentro de la coleccion jugadores"
	^ jugadores at: unaPosicion ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
jugadores
"es un metodo de prueba"
^ jugadores ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
nombre
	^ nombre ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
nombre:unNombre
	nombre := unNombre ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
partido: unaPosicion
	^ partidos at: unaPosicion ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
partidos 
	^ partidos ! !

Object subclass: #Jugador
	instanceVariableNames: 'name rankingInicial fechaIngreso partidos rankings partidosActualizados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Jugador class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:12'!
nuevoJugador: unNombre ranking: unNumero fecha: unaFecha
	"1era se crea solo el jugador
	2da se envia un mensje a un metodo que inplementa la creacion del jugador y inicializa la coleccion de 	ranking"
		
	"^ (self new) nombre: unNombre; rankinInicial: unNumero ; fechaIngreso: unaFecha " 
	
	^ (self new) jugadorNuevoJugador: unNombre  fecha: unaFecha  ranking: unNumero 
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:16'!
actualizarRanking: unaFecha
| rankingAntOponente partidoActual raj1Anterior raj2Anterior|
"Actualiza rankings dependientes del jugador actual despues de una determinada accion (eliminar, crear,asignar,editar rankings y partidos) apartir de la fecha recibida y enviara mensajes al oponente para que actialicen sus respectivos rankings"
	rankings do: [:ranking |  ( (ranking fecha >= unaFecha) & (ranking esAsignado = false))
		 ifTrue: [ 
				partidoActual := (self buscarPartidoFecha: ranking fecha).
			((self buscarPartidoListosFecha: partidoActual) = true)
			ifFalse: [
				(self name = (partidoActual jugador1 name ))			
				ifTrue: [
				raj1Anterior:=  (self jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking."raj1 ."
				raj2Anterior:= ((partidoActual jugador2  jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking).
				ranking ranking: (self jugadorObtenerRankingGamesA: (partidoActual gamesJugador1) gamesB:(partidoActual gamesJugador2)  rActualJa: raj1Anterior  rActualJb: raj2Anterior
									).
				partidosActualizados add: partidoActual .     
				partidoActual jugador2 actualizarRanking:(partidoActual fecha)
				]
				ifFalse: [
				raj2Anterior:=  (self jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking."raj1 ."
				raj1Anterior:= ((partidoActual jugador1  jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking).
			  ranking ranking:	(self jugadorObtenerRankingGamesA: (partidoActual gamesJugador2) gamesB:(partidoActual gamesJugador1)  rActualJa: raj2Anterior  rActualJb: raj1Anterior  
								).	
				partidosActualizados add: partidoActual .
				partidoActual jugador1 actualizarRanking:(partidoActual fecha)				
						]
			
					]
				 ]
			].
	"Borro coleccion de partidos ya actualizados"	
	partidosActualizados do: [:partido | partidosActualizados remove: partido ]	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:19'!
buscarPartidoFecha: unaFache
"Busca un partido por su fecha en la coleccion de partidos(variable de instancia)"
^ partidos detect: [:each | each fecha = unaFache ] ifNone:[nil].
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:19'!
buscarPartidoListosFecha: unPartido
|salida|
"Busca un partido en la coleccion de partidosActualiados(variable de instancia)"
salida := false.

partidosActualizados do: [:each | (each == unPartido ) ifTrue: [salida := true] ].
^ salida 
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/23/2013 18:21'!
dentroRangoRanking: valorInferior superior: valorSuperior
| rankingActual |
"Retorna verdadero si el ranking actual esta dentro del rango especificado"

rankingActual := self rankings last ranking.
 (((rankingActual) >= valorInferior) & ((rankingActual) <= valorSuperior ))
	ifTrue: [^ true ]
	ifFalse: [^ nil] ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:09'!
fechaIngreso 
	^ fechaIngreso ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:09'!
fechaIngreso: unaFecha
	fechaIngreso := unaFecha ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:09'!
initialize 
	partidos := OrderedCollection new.
	rankings := OrderedCollection new.
	partidosActualizados  := OrderedCollection new! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:09'!
jugadorAgregarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
| rna |
	partidos add: unPartido.
	self ordenarColeccion: partidos  por: 'X'  orden: 'X'	.
		
	(self name = (unPartido jugador1 name ))
			ifTrue: [
				rna :=	self jugadorObtenerRankingGamesA: (unPartido gamesJugador1) gamesB:(unPartido gamesJugador2)  rActualJa: raj1  rActualJb: raj2 
		     ]
	ifFalse: [
			  rna :=	self jugadorObtenerRankingGamesA: (unPartido gamesJugador2) gamesB:(unPartido gamesJugador1)  rActualJa: raj2  rActualJb: raj1 
		].
	
	self jugadorAsignarRanking: rna fecha: (unPartido fecha)  esAsignado: false
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:23'!
jugadorAsignarRanking: unNumero fecha: unaFecha esAsignado: unaBandera
| rankingSalida |
"Agrega ranking en la coleccion de rankings(variable de instancia) ordena la coleccion y actualiza los ranking dependientes si es necesario"

	rankings add: (Ranking nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera ).
	
	self ordenarColeccion: rankings  por: 'X' orden:'X'.
	
	self actualizarRanking: unaFecha! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:25'!
jugadorBuscarRankingAnteriorfecha: unaFecha
| rankingSalida coleccionAux |
"Recorre los ranking(variable de instancia) del jugador y retorna el ranking anterior a la fecha especificada"

	coleccionAux := OrderedCollection new.

				rankings do: [:each | ( each fecha < unaFecha )
												ifTrue: [coleccionAux add: each]
									  ]	.
			
	self ordenarColeccion: coleccionAux  por: 'X'  orden: 'X'.
	^ coleccionAux last.
	
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:27'!
jugadorBuscarRankingfecha: enFecha
| rankingSalida coleccionAux |
"Retorna el ranking del jugador que coincida con la fecha recibida por parametro si no coinciden las fechas se retorna el ranking anterior"

	coleccionAux := OrderedCollection new.
	rankingSalida := rankings detect: [:ranking | (ranking fecha) = enFecha ] ifNone:[nil] .
	(rankingSalida  = nil)
	 ifTrue:  [ 
				rankings do: [:each | ( each fecha < enFecha )
												ifTrue: [coleccionAux add: each]
									 ]
				 ]
	 ifFalse: [^ rankingSalida ] .
			
	self ordenarColeccion: coleccionAux  por: 'X'  orden: 'X'.
	^ coleccionAux last.
	
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:28'!
jugadorEditarPartido: enFecha nuevoResultado: nuevoResultado nuevafecha: nuevaFecha
| partido |
"Edita partido donde participo el jugador y actualiza los ranking dependientes si es necesario"			
	partido := self buscarPartidoFecha: enFecha.
	
	(partido ~= nil)	
		ifTrue: [
				partido fecha: nuevaFecha.partido gamesJugador1: (nuevoResultado at: 1).partido gamesJugador2: (nuevoResultado at: 2).
				self actualizarRanking: enFecha
		]! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:30'!
jugadorEditarRankingFecha: unaFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
| ranking |	
"Busca en la coleccion de rankings(variable de instancia) del jugador un ranking filtrado por fecha luego actualiza la fecha y el ranking, actualiza rankings dependientes si es necesario"
	
	ranking := self jugadorBuscarRankingfecha: unaFecha.
	
	(ranking ~= nil)
						ifTrue: [ranking fecha: nuevaFecha.ranking ranking: nuevoRanking.
									self ordenarColeccion: rankings  por: 'X' orden:'X' .
								 ].
							
	self actualizarRanking: unaFecha! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:31'!
jugadorEliminarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
"Elimina de partidos(variable de instancia) el partido especificado y actualiza rankings dependientes si es necesario"
| partidoLocal rankingLocal rna partidosDespues rankingsAct aux2 raj1Anterior  raj2Anterior partidoActual|

	rankingsAct := OrderedCollection new.partidosDespues := OrderedCollection new.
	partidos do: [:partido | (partido fecha = unPartido fecha) ifTrue: [ partidoLocal := partido.partidos remove: partido ] ].
	self ordenarColeccion: partidos  por: 'X'  orden: 'X'	." no deberia ser necesario"
		
	rankings do: [:ranking | (ranking fecha = unPartido fecha) ifTrue: [ rankingLocal := ranking.rankings remove: ranking ] ].	
	self ordenarColeccion: rankings por: 'X'  orden: 'X'	." no deberia ser necesario"	
	
	
	self actualizarRanking: (unPartido fecha)! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:33'!
jugadorEliminarRankingfecha: enFecha
| rankingSalida |
"Recorro los rankings(variable de instancia) del jugador y elimino el ranking de la fecha especificada, actualiza rankings dependientes si es necesario"

	rankings do: [:ranking | (ranking fecha = enFecha) ifTrue: [ rankings remove: ranking ] ].
	
	self actualizarRanking: enFecha! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
jugadorMisPartidos
	^ partidos ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:33'!
jugadorNuevoJugador: unNombre fecha: unaFecha ranking: unNumero
"Crea un nuevo jugador e inicializa rankings(bvariable de instancia) "
	
	self name: unNombre. self fechaIngreso: unaFecha . self rankingInicial: unNumero.
	
	rankings add: ( Ranking nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: true) .
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:34'!
jugadorObtenerRankingGamesA: ga gamesB: pa rActualJa: aRanking rActualJb: bRanking 
| rna ra ka gaa  sa ea ea1 paa rb |
"Retorna el valor del nuevo ranking aplicando la formula, esta formula se aplica a los aponentes de un partido esto dependiendo del orden de los parametros al momento de enviar el mensaje"
		     ra:= aRanking. "self misRankings last ranking .estoy utilizando el ultimo ranking, deberia ser el anterior a la fecha del part"
			  (ra < 1500)
							ifTrue: [ ka := 32]
							ifFalse: [ (ra > 1900) 
														ifTrue: [ka:= 16]
														ifFalse: [ka:=24]										
								].
			  " ga := unPartido gamesJugador1.	  pa := unPartido gamesJugador2."
			  (ga > pa ) ifTrue: [sa := 1] ifFalse: [sa := 0].
			  rb :=  bRanking . "unPartido jugador2 misRankings last ranking"
			
			ea1 := (( rb - ra) / 400). 	ea := (1 / ( 1 + (10 raisedTo: ea1))) roundTo: 0.000001.	
			rna := (ra + (ka * (sa - ea)) + ga - pa) roundTo: 0.000001 .
			^ rna! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:34'!
jugadorRankingSimilaresPorValor: unValor jugador: jugadores
	|rankingJugador rangoSuperior rangoInferior salida|
"Devuelve todos los jugadores cuyo ranking se encuentra por encima o
por debajo del ranking del jugador en cuestion no mas del valor ingresado.
podemos retornar el ranking actual de jugador each misRankings last ranking O el nombre del jugador each1 nombre
La coleccion que se esta retornando no esta ordenada por lo que no se tiene un patron para retornar los objetos "

	rankingJugador := self rankings last.

		(rankingJugador ~= nil)
			ifTrue: [	
						rangoInferior:= (rankingJugador ranking  - unValor ).
					 	rangoSuperior := (rankingJugador ranking  + unValor).		
						salida := OrderedCollection new.

						(jugadores select: [:each | ((each rankings last ranking  >= rangoInferior) & (each rankings  last ranking   <= rangoSuperior) ) ]) do: [:each1 | ( each1 name  ~= self name  ) ifTrue: [ salida add: each1 ] ]
												].
				
				^ salida ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
jugadorValidarFecha: unaFecha
"Es para validar que cuando se quiera agregar o editar un ranking por un partido o desicion de un administrador este ingreso sea valido, es decir no sea menor a la fecha ingreso y no se tenga otro partido ni ranking asignado el mismo dia y misma hora"

partidos detect: [:each | (each fecha = unaFecha )] ifNone:[
								((unaFecha > (self rankings first fecha )))
								ifTrue: [
											^ true
								]
																			].
^ false! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
name
	^ name ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
name: unNombre
	name := unNombre ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
ordenarColeccion: unaColeccion por: unCampo orden: unOrden
"Ordenada la coleccion por el campo fecha de manera ascendente, por ahora el criterio es asc no se implementado hacer un ordenamiento dinamico segun los parametros recibidos"
| i j tamanio r1 temp|

		i := 1.tamanio := unaColeccion size.
		[i < tamanio] whileTrue: [
		j := i+1.
			[j <= tamanio] whileTrue: [
				((unaColeccion at: i ) fecha > (unaColeccion at: j) fecha )
										ifTrue:  [temp := unaColeccion  at: i.
													unaColeccion at: i put: (unaColeccion at: j).
													unaColeccion at: j put: temp.
													].
				j := j + 1.
			].
		i := i + 1
		].
		
		^ unaColeccion! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
partidos 
	^ partidos ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
partidosActualizados
	^ partidosActualizados ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
rankingInicial 
	^ rankingInicial ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
rankingInicial: unNumero
	rankingInicial := unNumero ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
rankings 
	^ rankings ! !

Object subclass: #Partido
	instanceVariableNames: 'jugador1 jugador2 fecha gamesJugador1 gamesJugador2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Partido class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:15'!
agregarPartidoEntre: jugador1 y: jugador2 fecha: enFecha  gamesJugador1: g1 gamesJugador: g2

	^ (self new) jugador1: jugador1 ;jugador2: jugador2 ; fecha: enFecha; gamesJugador1: g1; gamesJugador2: g2
! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
fecha
	^ fecha ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
fecha: unaFecha
	fecha := unaFecha ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
gamesJugador1 
	^ gamesJugador1 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
gamesJugador1: unNumero
	gamesJugador1 := unNumero ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
gamesJugador1: nuevoGamesJugador1 gamesJugador2: nuevoGamesJugador2 fecha: nuevaFecha
	gamesJugador1:=nuevoGamesJugador1.
	gamesJugador2:=nuevoGamesJugador2.
	fecha:=nuevaFecha  ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
gamesJugador2 
	^ gamesJugador2 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
gamesJugador2: unNumero
	gamesJugador2 := unNumero ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
jugador1 
	^ jugador1 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
jugador1: unJugador
	jugador1 := unJugador ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
jugador2
	^ jugador2 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:05'!
jugador2: unJugador
	jugador2 := unJugador ! !

Object subclass: #Ranking
	instanceVariableNames: 'fecha ranking esAsignado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Ranking class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
nuevoRankingConFecha: unaFecha ranking: unNumero
	^ (self new) fecha: unaFecha ;ranking: unNumero ! !

!Ranking class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera
	^ (self new) fecha: unaFecha ;ranking: unNumero ; esAsignado: unaBandera ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 16:01'!
esAsignado
	" Indica si el ranking se cargo por una asignacion o como resultado de un partido"
	^ esAsignado ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 19:14'!
esAsignado: unaBandera
" Indica si el ranking se cargo por una asignacion o como resultado de un partido"
	esAsignado := unaBandera ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
fecha
	^ fecha! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
fecha: unafecha
	fecha := unafecha! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
initialize 
	esAsignado := false! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
ranking
	^ ranking ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:03'!
ranking: unNumero
	ranking := unNumero ! !

Object subclass: #SquashSystem
	instanceVariableNames: 'club'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!SquashSystem class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 15:15'!
newWithName: unNombre
	"voy a probar 
		1 si retorno desde aqui una instancia de ClubTp, practicamente llamare  a los metodos de ClubTp sin pasar por SquashSystem  
		2 si creo una instancia de SquashSytem, internamente creo el ClubTp y tendre en SquashSystem metodos que seran el puente a ClubTp  "
		
	" ^ ClubTp conNombre: unNombre ^ "
	
	^ self new club: unNombre 
	  
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:42'!
addMatchBetween: jugador1 and: jugador2 at: enFecha withResult: resultadoGames
"Envia mensaje al club para que procese el ingreso de un nuevo partido"
	self club clubNuevoPartidoJugador1: jugador1 jugador2: jugador2 fecha: enFecha  resultado: resultadoGames ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:41'!
addPlayer: nombreJugador withRanking: ranking  at: enFecha
"Envia mensaje al club para que procese el ingreso de un nuevo jugador"
	self club clubAgregarNuevoJugador: nombreJugador conRanking: ranking fecha: enFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:41'!
assignRanking: unNumero to: unNombre at: enFecha
"Envia mensaje al club para que procese la asignacion de una ranking a un jugador en una determinada fecha"
	self club clubAsignarRanking: unNumero nombre: unNombre fecha: enFecha! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 15:44'!
club 
"Retorna el club actual"
	^ club ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
club: nombreClub
"Crea un club y se asigna a una variable de instancia"
	club:= (Club nuevoConNombre: nombreClub )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:40'!
deleteMatchBetween: jugador1 and: jugador2 at: enFecha
"Envia mensaje al club para que elimine un partido en una determinada fecha"
	self club clubEliminarPartidoJugador1: jugador1 jugador2: jugador2  fecha: enFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:36'!
deleteRankingOf: nombreJugador at: enFecha
"Envia mensaje al club para que elimine un ranking de un jugador en una determinada fecha"
	self club clubEliminarRanking: nombreJugador  fecha: enFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:40'!
editMatchBetween:jugador1 and:jugador2 at: unaFecha withNewResult:unResultado andNewDate: unaNuevaFecha
"Envia mensaje al club para que edite el resultado de un partido"
	self club clubEditarPartidoEntre: jugador1 y:jugador2  fecha: unaFecha  nuevoResultado: unResultado  nuevafecha: unaNuevaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 17:51'!
editRankingOf: nombreJugador at: enFecha withNewValue: nuevoRanking andNewDate: nuevaFecha
"Envia mensaje al club para que edite el ranking de un jugador en una determinada fecha"
	self club clubEditarRanking: nombreJugador fecha: enFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:37'!
edithMatchBetween: jugador1 and:jugador2 at: unaFecha withNewResult:unResultado andNewDate: unaNuevaFecha
"Envia mensaje al club para que edite un partido en una determinada fecha"
	self club clubEditarPartidoEntre: jugador1 y:jugador2  fecha: unaFecha  nuevoResultado: unResultado  nuevafecha: unaNuevaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 14:53'!
initialize 
	" inicializa variables de instancia "
	" clubes := OrderedCollection new "
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:38'!
playersNear: nombreJugador by: unValor
"Envia mensaje al club para buscar jugadores cuyo ranking actual se encuentren dentro del rango especificado "
	^ self club clubJugadoresCercanos: nombreJugador  valor: unValor! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:39'!
playersRankedBetween: valorInferior and: valorSuperior
"Envia mensaje al club para buscar jugadores cuyo ranking actual se encuentren dentro del rango especificado "
	^ self club clubRankingJugadoresEntre: valorInferior y: valorSuperior 
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/22/2013 18:39'!
rankingOf: nombreJugador at: unaFecha
"Envia mensaje al club para buscar el ranking de un jugador en una determinada fecha"
	^ self club clubBuscarRanking: nombreJugador  fecha: unaFecha ! !

TestCase subclass: #TestCaseSquashTp
	instanceVariableNames: 'squashSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-TestCases'!

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 22:45'!
initialize 
	" squashSystem := SquashSystem new "! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/17/2013 18:39'!
setUp 
	squashSystem := SquashSystem newWithName: 'La Plata Squash Club'.
	
	squashSystem addPlayer: 'Ralph' withRanking: 1400 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Gail' withRanking: 2000 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Henry' withRanking: 1600 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Mark' withRanking: 1000 at: '2013-06-01' asDateAndTime.	
	squashSystem addPlayer: 'George' withRanking: 800 at: '2013-06-05' asDateAndTime.
	
	squashSystem addMatchBetween: 'Ralph' and: 'Gail' at: '2013-06-03' asDateAndTime withResult: #(3 2).
	squashSystem addMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime withResult: #(3 0).
	squashSystem addMatchBetween: 'Gail' and: 'Henry' at: '2013-06-05' asDateAndTime withResult: #(1 3).
	squashSystem addMatchBetween: 'Henry' and: 'George' at: '2013-06-07' asDateAndTime withResult: #(3 1).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 22:45'!
tearDown 
	" squashSystem := nil "! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 13:43'!
test01

	self assert: ((squashSystem rankingOf: 'Henry' at: '2013-06-06' asDateAndTime) closeTo: 1627.311424).
	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1629.514771).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-06' asDateAndTime) closeTo: 800).	
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7288709).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-06' asDateAndTime) closeTo: 1967.106627).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.106627).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/17/2013 18:39'!
test02

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1625.829881).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7231018).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1983.490455).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.07565).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 11:17'!
test03

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
 	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1616.219393).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7074759).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1600).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1586).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 11:22'!
test04

 
"   squashSystem assignRanking: 1600 to: 'Ralph' at: '2013-06-04' asDateAndTime.
   squashSystem deleteRankingOf: 'Ralph' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Ralph' at:'2013-06-01' asDateAndTime) closeTo: 1400)."
	
   squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
   squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.
   squashSystem deleteRankingOf: 'Gail' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1625.829881).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7231018).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1983.490455).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.07565).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 11:23'!
test05

" squashSystem editRankingOf: 'Ralph' at: '2013-06-01' asDateAndTime withNewValue: 800 andNewDate: '2013-06-01' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Ralph' at:'2013-06-01' asDateAndTime) closeTo: 800)."	


	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.	
 	squashSystem editRankingOf: 'Henry' at: '2013-06-01' asDateAndTime withNewValue: 800 andNewDate: '2013-06-01' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 850.1368426).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 783.5463257).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1600).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1574.237624).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 11:52'!
test06

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.
 	squashSystem editMatchBetween: 'Gail' and: 'Henry' at: '2013-06-05' asDateAndTime withNewResult: #(3 0) andNewDate: '2013-06-05' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.654903154728).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 09:30'!
test07

	| playersCollection |

	playersCollection := squashSystem playersRankedBetween: 800 and: 1500.
	self assert: playersCollection size equals: 2.
	self assert: ((playersCollection at:1) name = 'Ralph').
	self assert: ((playersCollection at:2) name = 'Mark').! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 01:11'!
test08

	| playersCollection |

	playersCollection := squashSystem playersNear:'Mark' by: 300.
	self assert: playersCollection size equals: 1.
	self assert: ((playersCollection at:1) name = 'George').

! !
